abstract class caGraafinenOlio {
  private int x,y;
  private boolean nakyy;

  private boolean paikka(int x, int y){
    this.x = x; this.y = y;
    return false;
  }

  caGraafinenOlio(int x, int y) { paikka(x,y); nakyy = false; }
  caGraafinenOlio() { this(0,0); }

  abstract boolean piirra(); {}
  final boolean nakyvissa() { return nakyy; }

  final boolean sammuta()
  {
    if ( !nakyvissa() ) return true;
    System.out.print("Sammutettu: ");
    nakyy = false;
    return piirra();
  }

  final boolean sytyta()
  {
    if ( nakyvissa() ) return true;
    System.out.print("Sytytetty:  ");
    nakyy = true;
    return piirra();
  }

  boolean siirra(int x, int y) {
    if ( !nakyvissa() ) return paikka(x,y);
    sammuta(); paikka(x,y); return sytyta();
  }

  boolean tulosta(String s) {
    System.out.print(tasaaOik(getClass().getName(),10)+": "
                     +tasaaOik(s,10)+
                     " ("+tasaaVas(""+x,2)+","+tasaaVas(""+y,2)+")" );
    return false;
  }

  public String tasaaOik(String str,int koko) {
    while(str.length() < koko) str += " ";
    return str;
  }

  public String tasaaVas(String str,int koko) {
    while(str.length() < koko) str = " " + str;
    return str;
  }

}


abstract class caSateellinenOlio extends caGraafinenOlio {
  private int r;

  private boolean koko(int r) {
    this.r = r; return false;
  }

  caSateellinenOlio(int x, int y, int r) { super(x,y); this.r = r; }
  caSateellinenOlio(int x, int y) { this(x,y,1); }
  caSateellinenOlio() { this(0,0,1); }

  boolean tulosta(String s) {
    super.tulosta(s);
    System.out.print(" r="+r);
    return false;
  }

  boolean muuta_koko(int r) {
    if ( !nakyvissa() ) return koko(r);
    sammuta(); koko(r); return sytyta();
  }
}


class cPiste extends caGraafinenOlio {

  cPiste(int x, int y) { super(x,y); }
  cPiste() { this(0,0); }

  boolean piirra() {
    tulosta("Piste"); System.out.println();
    return false;
  }
}


class cYmpyra extends caSateellinenOlio {

  cYmpyra(int x, int y, int r) { super(x,y,r); }
  cYmpyra(int x, int y) { this(x,y,1); }
  cYmpyra() { this(0,0,1); }

  boolean piirra() {
    tulosta("Ympyra");  System.out.println();
    return false;
  }
}


public class Oliot {

  public static void main(String[] argv)
  {
    caGraafinenOlio p;
    caGraafinenOlio[] kuvat = new caGraafinenOlio[10];

    cPiste p1 = new cPiste(),p2 = new cPiste(10,20);
    cYmpyra y1 = new cYmpyra(1,1,2);
    p1.sytyta(); p2.sytyta();
    p1.siirra(7,8);
    y1.sytyta(); y1.muuta_koko(5);

    p = new cYmpyra(9,9,9);
    p.sytyta(); p.siirra(8,8);
    if ( p instanceof caSateellinenOlio )
      ((caSateellinenOlio) p).muuta_koko(4);

    kuvat[0] = new cYmpyra(10,10,100);
    kuvat[1] = new cPiste(11,11);
    kuvat[2] = new cYmpyra(12,12,102);
    kuvat[3] = null;
    for(int i = 0; kuvat[i] != null; i++ ) kuvat[i].sytyta();
  }

}

