/* Title:         TimerBean -ajastin
   Author:        Markku Lehtinen
   Date:          Nov -97
   Description:   Tm bean lhett TimerEvent -viestin
                  jaksottain annetulla jaksonajalla.

                  Properties:
                  ===========

                  long timeSlice      TimerEvent -viestien aikavli.

                  Methods:
                  ========

                  startTimer()        Kynnist ajastimen, mikli se
                                      ei jo ole kynniss.

                  stopTimer()         Pysytt ajastimen.


                  Events:
                  =======

                  TimerEvent      Lhetetn rekisteridyille Listener:eille
                                  annetun aikajakson vlein.


                  HUOM! Ajastin saadaan kyntiin ensimmist kertaa ainoastaan
                        setTimeSlice() -kutsulla, jossa parametrina on
                        jokin postitiivinen aikavli.
*/

package omat.timer;

import java.awt.*;
import java.awt.event.*;
import borland.jbcl.util.*;
import java.util.*;

public class TimerBean implements BlackBox{
  private Vector listenerList = new Vector();
  boolean timerOn = false,firstTime = true;

  BeanTimerClient btClient = new BeanTimerClient(this);
  Timer beanTimer = new Timer();

  public TimerBean() {}

// Methods
  public void stopTimer() {
    if ( !timerOn ) return;
    beanTimer.stopTimer(btClient,1);
    timerOn = false;
  }

  public void startTimer() {
    if ( firstTime ) return;
    if ( timerOn ) return;
    beanTimer.startTimer(btClient,1,timeSlice,true);
    timerOn = true;
  }

// TimerEvent
  public void fireTimerEvent() {
    processTimerEvent(new TimerEvent(this));
  }

  protected void processTimerEvent(TimerEvent e) {
     for (int i=0; i<listenerList.size(); i++)
       ((TimerEventListener)listenerList.elementAt(i)).timerAction(e);
  }

  public synchronized void addTimerEventListener(TimerEventListener l) {
    listenerList.addElement(l);
  }
  public synchronized void removeTimerEventListener(TimerEventListener l){
    listenerList.removeElement(l);
  }

// timeSlice
  private long timeSlice;

  public void setTimeSlice(long slice) {
    if ( slice <= 0 ) return;
    timeSlice = slice;
    if ( firstTime ) { firstTime = false; startTimer(); }
    if ( timerOn ) { stopTimer(); startTimer(); }
  }

  public long getTimeSlice(){
    return timeSlice;
  }
}

class BeanTimerClient implements TimerClient {
  TimerBean bean;

  BeanTimerClient(TimerBean bean) { this.bean = bean; }
  public void timerEvent(int id) { bean.fireTimerEvent(); }
}

